#include "stdio.h"

#define SIZE 5 

typedef struct {
    int buffer[SIZE]  ;
	int len ;
	int wp  ;
	int rp ;
 } queue_t;

void initQ(queue_t * q) ;
int addQ(queue_t * q , int element ) ;
int removeQ(queue_t * q , int * element) ;
void printQ(queue_t q);

int main() {
	int a ;
	queue_t q1 ;
	initQ(&q1);
	
	addQ(&q1, 10 ) ; printQ(q1); 
	addQ(&q1, 20 ) ; printQ(q1); 
	addQ(&q1, 30 ) ; printQ(q1); 
	addQ(&q1, 40 ) ; printQ(q1); 
	addQ(&q1, 50 ) ; printQ(q1); 
	addQ(&q1, 60 ) ; printQ(q1); 
	addQ(&q1, 70 ) ; printQ(q1); 
	 

	removeQ(&q1 , &a) ; printf(">>%d\n", a );
	removeQ(&q1 , &a) ; printf(">>%d\n", a ); 
	printQ(q1); 

	addQ(&q1, 80 ) ; printQ(q1); 
	addQ(&q1, 90 ) ; printQ(q1); 
	 

	removeQ(&q1 , &a) ; printf(">>%d\n", a );
	printQ(q1); 

	return 0 ;
}


void initQ(queue_t * q) {
	q->len = 0 ;
	q->wp = 0 ;
	q->rp = 0 ;
}

int addQ(queue_t * q , int element ) {
	
	if (q->len < SIZE ) {
		q->buffer[q->wp] = element ;
		q->wp = (q->wp + 1)%SIZE ;
		q->len ++ ;
		return 0 ;
	}
	else
		return -1;

}

int removeQ(queue_t * q , int * element) {
	
	if (q->len > 0 ) {
		*element = q->buffer[q->rp] ;
		q->rp = (q->rp + 1)%SIZE ;
		q->len -- ;
		return 0 ;
	}
	else
		return -1;

}

void printQ(queue_t q) {
	int i ;

	for(i=0 ; i<q.len ; i++) 
		printf("%d " , q.buffer[(i+q.rp)%SIZE] );

	printf("\n");
}